#pragma once
#include <string>
#include <vector>
#include <map>
#include "CivSchedulingCompute.h"

using namespace std;

class CivSchedulingCompute;
/**
  Żȿͻ
*/
class CivOptSchedEngine
{
public:
	explicit CivOptSchedEngine(const string& uri);

	bool optimalScheduling(int time);

	// ü
	void updateMonitorsVals(const map<string,double>& monitorVals);

	/**
	*@brief ı
	* @param [monitor] ı
	*/
	void setMonitors(const vector<string>& monitor);

	/**
	*@brief ҪȵʱΣΧΪ0-24
	* @param [time] ȵʱ
	*/
	void setSchedulingPeriod(int time) { mPeriod = time; }

protected:
	/**
	*@brief תΪjsonַ
	*@param [out] json ַ
	*/
	void schedulingResultToJson(string& json);

	/**
	*@brief ֮ǰһЩʼ
	*/
	bool beginCompute();

	/**
	*@brief ֮һЩβ
	*/
	void endCompute();

private:
	// ״̬ӳ
	map<int, string> mStatusBit;

	// ѡ
	map<string, double> mPumpBestSpeed;

	// 
	vector<string>& mMonitorsVec;

	// ʵʱĵǰֵ
	map<string,double> mCurrentMonitorVals;

	// ѹĽֵ
	map<string, double> mMaxMonitorVals;
	map<string, double> mMinMonitorVals;

	map<string, double> mBforeSchedulingResults;
	map<string, double> mAfterSchedulingResults;

	// ӵַ
	string mUri;

	// ȵǸʱ
	int mPeriod;

	// ʼȺС
	int popsize;

	// 
	double mMutRate;

	// 
	double mCrossRate;

	//볤
	int mGenLength;

	// Ը
	double mLeftPoint;
	double mRightPoint;

	std::shared_ptr<CivSchedulingCompute> mSchedulingCompute;
};
